Index: arch/parisc/math-emu/fcnvfxt.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/parisc/math-emu/fcnvfxt.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/parisc/math-emu/fcnvfxt.c	22 Jul 2004 19:49:24 -0000	1.1
+++ arch/parisc/math-emu/fcnvfxt.c	4 Aug 2004 01:26:03 -0000	1.2
@@ -22,7 +22,7 @@
  * BEGIN_DESC
  *
  *  File:
- *	@(#)	pa/spmath/fcnvfxt.c		$Revision: 1.1 $
+ *	@(#)	pa/spmath/fcnvfxt.c		$Revision: 1.2 $
  *
  *  Purpose:
  *	Single Floating-point to Single Fixed-point /w truncated result
Index: arch/parisc/math-emu/fcnvuf.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/parisc/math-emu/fcnvuf.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/parisc/math-emu/fcnvuf.c	22 Jul 2004 19:49:24 -0000	1.1
+++ arch/parisc/math-emu/fcnvuf.c	4 Aug 2004 01:26:03 -0000	1.2
@@ -22,7 +22,7 @@
  * BEGIN_DESC
  *
  *  File:
- *	@(#)	pa/spmath/fcnvuf.c		$Revision: 1.1 $
+ *	@(#)	pa/spmath/fcnvuf.c		$Revision: 1.2 $
  *
  *  Purpose:
  *	Fixed point to Floating-point Converts
Index: arch/parisc/math-emu/fcnvxf.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/parisc/math-emu/fcnvxf.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/parisc/math-emu/fcnvxf.c	22 Jul 2004 19:49:24 -0000	1.1
+++ arch/parisc/math-emu/fcnvxf.c	4 Aug 2004 01:26:03 -0000	1.2
@@ -22,7 +22,7 @@
  * BEGIN_DESC
  *
  *  File:
- *	@(#)	pa/spmath/fcnvxf.c		$Revision: 1.1 $
+ *	@(#)	pa/spmath/fcnvxf.c		$Revision: 1.2 $
  *
  *  Purpose:
  *	Single Fixed-point to Single Floating-point
Index: arch/parisc/math-emu/float.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/parisc/math-emu/float.h,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/parisc/math-emu/float.h	22 Jul 2004 19:49:24 -0000	1.1
+++ arch/parisc/math-emu/float.h	4 Aug 2004 01:26:04 -0000	1.2
@@ -22,7 +22,7 @@
  * BEGIN_DESC
  * 
  *  File: 
- *      @(#)	pa/spmath/float.h		$Revision: 1.1 $
+ *      @(#)	pa/spmath/float.h		$Revision: 1.2 $
  * 
  *  Purpose:
  *      <<please update with a synopis of the functionality provided by this file>>
Index: arch/parisc/math-emu/fmpyfadd.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/parisc/math-emu/fmpyfadd.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/parisc/math-emu/fmpyfadd.c	22 Jul 2004 19:49:24 -0000	1.1
+++ arch/parisc/math-emu/fmpyfadd.c	4 Aug 2004 01:26:05 -0000	1.2
@@ -22,7 +22,7 @@
  * BEGIN_DESC
  *
  *  File:
- *	@(#)	pa/spmath/fmpyfadd.c		$Revision: 1.1 $
+ *	@(#)	pa/spmath/fmpyfadd.c		$Revision: 1.2 $
  *
  *  Purpose:
  *	Double Floating-point Multiply Fused Add
Index: arch/parisc/math-emu/fpu.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/parisc/math-emu/fpu.h,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/parisc/math-emu/fpu.h	22 Jul 2004 19:49:24 -0000	1.1
+++ arch/parisc/math-emu/fpu.h	4 Aug 2004 01:26:05 -0000	1.2
@@ -22,7 +22,7 @@
  * BEGIN_DESC
  * 
  *  File: 
- *      @(#)	pa/fp/fpu.h		$Revision: 1.1 $
+ *      @(#)	pa/fp/fpu.h		$Revision: 1.2 $
  * 
  *  Purpose:
  *      <<please update with a synopis of the functionality provided by this file>>
Index: arch/parisc/math-emu/fpudispatch.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/parisc/math-emu/fpudispatch.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/parisc/math-emu/fpudispatch.c	22 Jul 2004 19:49:24 -0000	1.1
+++ arch/parisc/math-emu/fpudispatch.c	4 Aug 2004 01:26:05 -0000	1.2
@@ -22,7 +22,7 @@
  * BEGIN_DESC
  *
  *  File:
- *	@(#)	pa/fp/fpudispatch.c		$Revision: 1.1 $
+ *	@(#)	pa/fp/fpudispatch.c		$Revision: 1.2 $
  *
  *  Purpose:
  *	<<please update with a synopsis of the functionality provided by this file>>
@@ -51,6 +51,7 @@
 
 #include "float.h"
 #include "types.h"
+#include <asm/processor.h>
 /* #include <sys/debug.h> */
 /* #include <machine/sys/mdep_private.h> */
 
@@ -166,6 +167,20 @@
 
 #define VASSERT(x)
 
+static void parisc_linux_get_fpu_type(u_int fpregs[])
+{
+	/* on pa-linux the fpu type is not filled in by the
+	 * caller; it is constructed here  
+	 */ 
+	if (boot_cpu_data.cpu_type == pcxs)
+		fpregs[FPU_TYPE_FLAG_POS] = TIMEX_EXTEN_FLAG;
+	else if (boot_cpu_data.cpu_type == pcxt ||
+	         boot_cpu_data.cpu_type == pcxt_)
+		fpregs[FPU_TYPE_FLAG_POS] = ROLEX_EXTEN_FLAG;
+	else if (boot_cpu_data.cpu_type >= pcxu)
+		fpregs[FPU_TYPE_FLAG_POS] = PA2_0_FPU_FLAG;
+}
+
 /*
  * this routine will decode the excepting floating point instruction and
  * call the approiate emulation routine.
@@ -184,6 +199,8 @@
 	/* All FP emulation code assumes that ints are 4-bytes in length */
 	VASSERT(sizeof(int) == 4);
 
+	parisc_linux_get_fpu_type(fpregs);
+
 	fpu_type_flags=fpregs[FPU_TYPE_FLAG_POS];  /* get fpu type flags */
 
 	class = get_class(ir);
Index: arch/parisc/math-emu/sfadd.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/parisc/math-emu/sfadd.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/parisc/math-emu/sfadd.c	22 Jul 2004 19:49:24 -0000	1.1
+++ arch/parisc/math-emu/sfadd.c	4 Aug 2004 01:26:05 -0000	1.2
@@ -22,7 +22,7 @@
  * BEGIN_DESC
  *
  *  File:
- *	@(#)	pa/spmath/sfadd.c		$Revision: 1.1 $
+ *	@(#)	pa/spmath/sfadd.c		$Revision: 1.2 $
  *
  *  Purpose:
  *	Single_add: add two single precision values.
Index: arch/parisc/math-emu/sfcmp.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/parisc/math-emu/sfcmp.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/parisc/math-emu/sfcmp.c	22 Jul 2004 19:49:24 -0000	1.1
+++ arch/parisc/math-emu/sfcmp.c	4 Aug 2004 01:26:06 -0000	1.2
@@ -22,7 +22,7 @@
  * BEGIN_DESC
  *
  *  File:
- *	@(#)	pa/spmath/sfcmp.c		$Revision: 1.1 $
+ *	@(#)	pa/spmath/sfcmp.c		$Revision: 1.2 $
  *
  *  Purpose:
  *	sgl_cmp: compare two values
Index: arch/parisc/math-emu/sfdiv.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/parisc/math-emu/sfdiv.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/parisc/math-emu/sfdiv.c	22 Jul 2004 19:49:24 -0000	1.1
+++ arch/parisc/math-emu/sfdiv.c	4 Aug 2004 01:26:06 -0000	1.2
@@ -22,7 +22,7 @@
  * BEGIN_DESC
  *
  *  File:
- *	@(#)	pa/spmath/sfdiv.c		$Revision: 1.1 $
+ *	@(#)	pa/spmath/sfdiv.c		$Revision: 1.2 $
  *
  *  Purpose:
  *	Single Precision Floating-point Divide
Index: arch/parisc/math-emu/sfmpy.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/parisc/math-emu/sfmpy.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/parisc/math-emu/sfmpy.c	22 Jul 2004 19:49:24 -0000	1.1
+++ arch/parisc/math-emu/sfmpy.c	4 Aug 2004 01:26:06 -0000	1.2
@@ -22,7 +22,7 @@
  * BEGIN_DESC
  *
  *  File:
- *	@(#)	pa/spmath/sfmpy.c		$Revision: 1.1 $
+ *	@(#)	pa/spmath/sfmpy.c		$Revision: 1.2 $
  *
  *  Purpose:
  *	Single Precision Floating-point Multiply
Index: arch/parisc/math-emu/sfrem.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/parisc/math-emu/sfrem.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/parisc/math-emu/sfrem.c	22 Jul 2004 19:49:24 -0000	1.1
+++ arch/parisc/math-emu/sfrem.c	4 Aug 2004 01:26:06 -0000	1.2
@@ -22,7 +22,7 @@
  * BEGIN_DESC
  *
  *  File:
- *	@(#)	pa/spmath/sfrem.c		$Revision: 1.1 $
+ *	@(#)	pa/spmath/sfrem.c		$Revision: 1.2 $
  *
  *  Purpose:
  *	Single Precision Floating-point Remainder
Index: arch/parisc/math-emu/sfsqrt.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/parisc/math-emu/sfsqrt.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/parisc/math-emu/sfsqrt.c	22 Jul 2004 19:49:24 -0000	1.1
+++ arch/parisc/math-emu/sfsqrt.c	4 Aug 2004 01:26:06 -0000	1.2
@@ -22,7 +22,7 @@
  * BEGIN_DESC
  *
  *  File:
- *	@(#)	pa/spmath/sfsqrt.c		$Revision: 1.1 $
+ *	@(#)	pa/spmath/sfsqrt.c		$Revision: 1.2 $
  *
  *  Purpose:
  *	Single Floating-point Square Root
Index: arch/parisc/math-emu/sfsub.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/parisc/math-emu/sfsub.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/parisc/math-emu/sfsub.c	22 Jul 2004 19:49:24 -0000	1.1
+++ arch/parisc/math-emu/sfsub.c	4 Aug 2004 01:26:06 -0000	1.2
@@ -22,7 +22,7 @@
  * BEGIN_DESC
  *
  *  File:
- *	@(#)	pa/spmath/sfsub.c		$Revision: 1.1 $
+ *	@(#)	pa/spmath/sfsub.c		$Revision: 1.2 $
  *
  *  Purpose:
  *	Single_subtract: subtract two single precision values.
Index: arch/parisc/mm/fault.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/parisc/mm/fault.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/parisc/mm/fault.c	22 Jul 2004 19:49:24 -0000	1.1
+++ arch/parisc/mm/fault.c	4 Aug 2004 01:26:06 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: fault.c,v 1.1 2004/07/22 19:49:24 joff Exp $
+/* $Id: fault.c,v 1.2 2004/08/04 01:26:06 joff Exp $
  *
  * This file is subject to the terms and conditions of the GNU General Public
  * License.  See the file "COPYING" in the main directory of this archive
Index: arch/parisc/tools/Makefile
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/parisc/tools/Makefile,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/parisc/tools/Makefile	22 Jul 2004 19:49:24 -0000	1.1
+++ arch/parisc/tools/Makefile	4 Aug 2004 01:26:06 -0000	1.2
@@ -3,7 +3,7 @@
 # Copyright (C) 1996 David S. Miller (dm@engr.sgi.com)
 # Copyright (C) 1997 Ralf Baechle (ralf@gnu.ai.mit.edu)
 #
-# $Id: Makefile,v 1.1 2004/07/22 19:49:24 joff Exp $
+# $Id: Makefile,v 1.2 2004/08/04 01:26:06 joff Exp $
 #
 TARGET	:= $(TOPDIR)/include/asm-$(ARCH)/offset.h
 
Index: arch/parisc/tools/offset.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/parisc/tools/offset.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/parisc/tools/offset.c	22 Jul 2004 19:49:24 -0000	1.1
+++ arch/parisc/tools/offset.c	4 Aug 2004 01:26:06 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: offset.c,v 1.1 2004/07/22 19:49:24 joff Exp $
+/* $Id: offset.c,v 1.2 2004/08/04 01:26:06 joff Exp $
  *
  * offset.c: Calculate pt_regs and task_struct offsets.
  *
Index: arch/ppc/Makefile
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/ppc/Makefile,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/ppc/Makefile	22 Jul 2004 19:48:59 -0000	1.1
+++ arch/ppc/Makefile	4 Aug 2004 01:26:06 -0000	1.2
@@ -14,11 +14,7 @@
 #
 
 # Be sure to change PAGE_OFFSET in include/asm-ppc/page.h to match
-KERNELLOAD	=0xc0000000
-
-ifeq ($(shell uname -m),ppc)
-CHECKS		= checks
-endif
+KERNELLOAD	=$(CONFIG_KERNEL_START)
 
 LINKFLAGS	= -T arch/ppc/vmlinux.lds -Ttext $(KERNELLOAD) -Bstatic
 CPPFLAGS	:= $(CPPFLAGS) -I$(TOPDIR)/arch/$(ARCH)
@@ -46,18 +42,13 @@
   CFLAGS += $(shell echo $(CONFIG_COMPILE_OPTIONS) | sed -e 's/"//g')
 endif
 
-ifdef CONFIG_4xx
-  HEAD := arch/ppc/kernel/head_4xx.o
-else
-  ifdef CONFIG_8xx
-    HEAD := arch/ppc/kernel/head_8xx.o
-  else
-    HEAD := arch/ppc/kernel/head.o
-    ifdef CONFIG_6xx
-	HEAD += arch/ppc/kernel/idle_6xx.o
-    endif
-  endif
-endif
+HEAD-y			:= arch/ppc/kernel/head.o
+HEAD-$(CONFIG_40x)	:= arch/ppc/kernel/head_4xx.o
+HEAD-$(CONFIG_44x)	:= arch/ppc/kernel/head_44x.o
+HEAD-$(CONFIG_8xx)	:= arch/ppc/kernel/head_8xx.o
+HEAD-$(CONFIG_6xx)	+= arch/ppc/kernel/idle_6xx.o
+
+HEAD := $(HEAD-y)
 
 ARCH_SUBDIRS = arch/ppc/kernel arch/ppc/platforms arch/ppc/mm arch/ppc/lib
 SUBDIRS := $(SUBDIRS) $(ARCH_SUBDIRS)
@@ -81,9 +72,9 @@
 DRIVERS += arch/ppc/8xx_io/8xx_io.o
 endif
 
-ifdef CONFIG_8260
-SUBDIRS += arch/ppc/8260_io
-DRIVERS += arch/ppc/8260_io/8260_io.o
+ifdef CONFIG_CPM2
+SUBDIRS += arch/ppc/cpm2_io
+DRIVERS += arch/ppc/cpm2_io/cpm2_io.o
 endif
 
 ifdef CONFIG_APUS
@@ -94,12 +85,12 @@
 checks:
 	@$(MAKE) -C arch/$(ARCH)/kernel checks
 
-BOOT_TARGETS = zImage zImage.initrd znetboot znetboot.initrd
+BOOT_TARGETS = zImage zImage.initrd znetboot znetboot.initrd uImage
 
 # All the instructions talk about "make bzImage".
 bzImage: zImage
 
-$(BOOT_TARGETS): $(CHECKS) vmlinux
+$(BOOT_TARGETS): vmlinux
 	@$(MAKEBOOT) $@
 
 %_config: arch/ppc/configs/%_defconfig
Index: arch/ppc/config.in
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/ppc/config.in,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/ppc/config.in	22 Jul 2004 19:48:59 -0000	1.1
+++ arch/ppc/config.in	4 Aug 2004 01:26:06 -0000	1.2
@@ -13,6 +13,7 @@
 mainmenu_option next_comment
 comment 'Code maturity level options'
 bool 'Prompt for development and/or incomplete code/drivers' CONFIG_EXPERIMENTAL
+bool 'Prompt for advanced kernel configuration options' CONFIG_ADVANCED_OPTIONS
 endmenu
 
 mainmenu_option next_comment
@@ -30,11 +31,16 @@
 define_bool CONFIG_PPC32 y
 choice 'Processor Type'	\
 	"6xx/7xx/74xx/8260	CONFIG_6xx	\
-	 4xx			CONFIG_4xx	\
-	 POWER3               	CONFIG_POWER3	\
-	 POWER4        	        CONFIG_POWER4	\
+	 40x			CONFIG_40x	\
+	 44x			CONFIG_44x	\
+	 POWER3			CONFIG_POWER3	\
+	 POWER4			CONFIG_POWER4	\
 	 8xx			CONFIG_8xx"	6xx
 
+if [ "$CONFIG_40x" = "y" -o "$CONFIG_44x" = "y" ]; then
+  define_bool CONFIG_4xx y
+fi
+
 if [ "$CONFIG_6xx" = "y" ]; then
   bool 'MPC8260 CPM Support' CONFIG_8260
 fi
@@ -48,42 +54,62 @@
 if [ "$CONFIG_6xx" = "y" -o "$CONFIG_POWER3" = "y" -o \
      "$CONFIG_POWER4" = "y" ]; then
   define_bool CONFIG_PPC_STD_MMU y
-else
-  define_bool CONFIG_PPC_STD_MMU n
 fi
 
 if [ "$CONFIG_8260" = "y" ]; then
   define_bool CONFIG_SERIAL_CONSOLE y
-  bool 'Support for EST8260' CONFIG_EST8260
-fi
-
-if [ "$CONFIG_4xx" = "y" ]; then
-  choice 'Machine Type'			\
-	"Oak			CONFIG_OAK 	\
-	 Walnut			CONFIG_WALNUT"	Oak
-  if [ "$CONFIG_WALNUT" = "y" ]; then
-    define_bool CONFIG_IBM405_ERR77 y
-  fi
+  define_bool CONFIG_CPM2 y
+  bool '  MPC8272 Family Support' CONFIG_8272
+  choice 'Machine Type'	\
+	"ADS8272	CONFIG_ADS8272	\
+	 EST8260	CONFIG_EST8260 \
+	 RPX8260	CONFIG_RPX6"	RPX8260
+fi
+
+if [ "$CONFIG_ADS8272" = "y" ]; then
+  define_bool CONFIG_PQ2ADS y
+fi
+
+if [ "$CONFIG_40x" = "y" ]; then
+    choice 'Machine Type'			\
+	 "CPCI405	CONFIG_CPCI405 		\
+	 EP405/EP405PC	CONFIG_EP405 		\
+	 Redwood-5	CONFIG_REDWOOD_5 	\
+	 Redwood-6	CONFIG_REDWOOD_6 	\
+	 Oak		CONFIG_OAK		\
+	 Walnut		CONFIG_WALNUT"		Walnut
+
+   if [ "$CONFIG_EP405" = "y" ]; then
+      bool 'EP405PC Support' CONFIG_EP405PC
+   fi
+fi
+
+if [ "$CONFIG_44x" = "y" ]; then
+    choice 'Machine Type'			\
+	 "Ebony		CONFIG_EBONY		\
+	 Ocotea		CONFIG_OCOTEA"		Ebony
 fi
 
 if [ "$CONFIG_8xx" = "y" ]; then
   define_bool CONFIG_SERIAL_CONSOLE y
+  define_bool CONFIG_NOT_COHERENT_CACHE y
 
   choice 'Machine Type'		\
 	"RPX-Lite	CONFIG_RPXLITE		\
 	 RPX-Classic	CONFIG_RPXCLASSIC	\
 	 BSE-IP		CONFIG_BSEIP		\
 	 FADS		CONFIG_FADS		\
- 	 TQM823L	CONFIG_TQM823L		\
- 	 TQM850L	CONFIG_TQM850L		\
- 	 TQM855L	CONFIG_TQM855L		\
-  	 TQM860L	CONFIG_TQM860L		\
- 	 FPS850L	CONFIG_FPS850L		\
-  	 TQM860		CONFIG_TQM860		\
- 	 SPD823TS	CONFIG_SPD823TS		\
- 	 IVMS8		CONFIG_IVMS8		\
+	 D-Box2		CONFIG_DBOX2		\
+	 TQM823L	CONFIG_TQM823L		\
+	 TQM850L	CONFIG_TQM850L		\
+	 TQM855L	CONFIG_TQM855L		\
+	 TQM860L	CONFIG_TQM860L		\
+	 FPS850L	CONFIG_FPS850L		\
+	 TQM860		CONFIG_TQM860		\
+	 SPD823TS	CONFIG_SPD823TS		\
+	 IVMS8		CONFIG_IVMS8		\
 	 IVML24		CONFIG_IVML24		\
- 	 SM850		CONFIG_SM850		\
+	 SM850		CONFIG_SM850		\
 	 MBX		CONFIG_MBX		\
 	 WinCept	CONFIG_WINCEPT"		RPX-Lite
 
@@ -93,22 +119,25 @@
        "$CONFIG_TQM855L" = "y" -o \
        "$CONFIG_TQM860L" = "y" -o \
        "$CONFIG_SM850"   = "y" ]; then
- 	define_bool	CONFIG_TQM8xxL	y
+ 	define_bool CONFIG_TQM8xxL y
   fi
 fi
 
 if [ "$CONFIG_6xx" = "y" -a "$CONFIG_8260" = "n" ]; then
   choice 'Machine Type'		\
 	"CHRP/PowerMac/PReP	CONFIG_ALL_PPC		\
-  	 Amiga-APUS		CONFIG_APUS		\
+	 Amiga-APUS		CONFIG_APUS		\
 	 IBM-Spruce		CONFIG_SPRUCE		\
 	 Motorola-LoPEC		CONFIG_LOPEC		\
+	 Motorola-Sandpoint	CONFIG_SANDPOINT	\
+	 Motorola-PowerPlus	CONFIG_PPLUS		\
+	 Motorola-PrPMC750	CONFIG_PRPMC750		\
 	 SBS-Palomar4		CONFIG_PAL4		\
-	 Synergy-Gemini        	CONFIG_GEMINI"		CHRP/PowerMac/PReP
+	 Synergy-Gemini		CONFIG_GEMINI"		CHRP/PowerMac/PReP
 fi
 
-if [ "$CONFIG_SPRUCE" = "y" ]; then
-  define_bool CONFIG_GEN550 y
+if [ "$CONFIG_SANDPOINT" = "y" ]; then
+  bool 'Enable MPC10x store gathering' CONFIG_MPC10X_STORE_GATHERING
 fi
 
 if [ "$CONFIG_LOPEC" = "y" ]; then
@@ -116,13 +145,27 @@
   define_bool CONFIG_GEN550 y
 fi
 
-if [ "$CONFIG_PPC_STD_MMU" != "y" ]; then
-  define_bool CONFIG_ALL_PPC n
+if [ "$CONFIG_PPLUS" = "y" ]; then
+  define_bool CONFIG_GEN550 y
+fi
+
+if [ "$CONFIG_PRPMC750" = "y" ]; then
+  define_bool CONFIG_GEN550 y
+fi
+
+if [ "$CONFIG_SANDPOINT" = "y" ]; then
+  define_bool CONFIG_EPIC_SERIAL_MODE y
+  define_bool CONFIG_GEN550 y
+fi
+
+if [ "$CONFIG_SPRUCE" = "y" ]; then
+  define_bool CONFIG_GEN550 y
 fi
 
 bool 'Symmetric multi-processing support' CONFIG_SMP
 if [ "$CONFIG_SMP" = "y" ]; then
   bool '  Distribute interrupts on all CPUs by default' CONFIG_IRQ_ALL_CPUS
+  int  'Maximum number of CPUs (2-32)' CONFIG_NR_CPUS 32
 fi
 
 if [ "$CONFIG_6xx" = "y" -a "$CONFIG_8260" = "n" ];then
@@ -134,11 +177,125 @@
   fi
   define_bool CONFIG_PPC_ISATIMER y
 fi
+if [ "$CONFIG_POWER4" = "y" ]; then
+  bool 'VMX (same as AltiVec) support' CONFIG_ALTIVEC
+fi
 
 if [ "$CONFIG_4xx" = "y" -o "$CONFIG_8xx" = "y" ]; then
   bool 'Math emulation' CONFIG_MATH_EMULATION
 fi
 
+if [ "$CONFIG_4xx" = "y" ]; then
+
+#
+# Set generic PPC4xx options
+#
+  define_bool CONFIG_NOT_COHERENT_CACHE y
+
+  if [ "$CONFIG_40x" = "y" ]; then
+    choice 'TTYS0 device and default console'	\
+	"UART0  CONFIG_UART0_TTYS0		\
+	 UART1	CONFIG_UART0_TTYS1"		UART0
+  fi
+
+#
+# Set processor implementation based on board
+#
+
+  if [ "$CONFIG_CPCI405" = "y" ]; then
+    define_bool CONFIG_405GP y
+  fi
+
+  if [ "$CONFIG_EP405" = "y" ]; then
+    define_bool CONFIG_405GP y
+  fi
+
+  if [ "$CONFIG_OAK" = "y" -o "$CONFIG_TIVO" = "y" ]; then
+    define_bool CONFIG_403GCX y
+  fi
+
+  if [ "$CONFIG_REDWOOD_5" = "y" -o "$CONFIG_REDWOOD_6" = "y" ]; then
+    define_bool CONFIG_STB03xxx y
+  fi
+
+  if [ "$CONFIG_WALNUT" = "y" ]; then
+    define_bool CONFIG_405GP y
+  fi
+
+  if [ "$CONFIG_EBONY" = "y" ]; then
+    define_bool CONFIG_440GP y
+  fi
+
+  if [ "$CONFIG_OCOTEA" = "y" ]; then
+    define_bool CONFIG_440GX y
+  fi
+
+#
+# Set options based on processor implementation
+#
+  if [ "$CONFIG_405GP" = "y" -o "$CONFIG_STB03xxx" = "y" ]; then
+    define_bool CONFIG_IBM_OCP y
+    define_bool CONFIG_PPC_OCP y
+    define_bool CONFIG_405 y
+  fi
+
+  if [ "$CONFIG_440GP" = "y" ]; then
+    define_bool CONFIG_IBM_OCP y
+    define_bool CONFIG_PPC_OCP y
+    define_bool CONFIG_GEN550 y
+    define_bool CONFIG_440 y
+  fi
+
+  if [ "$CONFIG_440GX" = "y" ]; then
+    define_bool CONFIG_IBM_OCP y
+    define_bool CONFIG_PPC_OCP y
+    define_bool CONFIG_GEN550 y
+    define_bool CONFIG_IBM_EMAC4 y
+    define_bool CONFIG_440A y
+  fi
+
+#
+# Set options based on processor core
+#
+  if [ "$CONFIG_40x" = "y" ]; then
+    define_bool CONFIG_IBM405_ERR51 y
+  fi
+
+  if [ "$CONFIG_405" = "y" ]; then
+    define_bool CONFIG_IBM405_ERR77 y
+  fi
+
+  if [ "$CONFIG_44x" = "y" ]; then
+    define_bool CONFIG_PTE_64BIT y
+    define_bool CONFIG_PIN_TLB y
+    define_bool CONFIG_BOOKE y
+  fi
+
+  bool 'PPC4xx DMA controller support' CONFIG_PPC4xx_DMA
+  if [ "$CONFIG_PPC4xx_DMA" = "y" ]; then
+    if [ "$CONFIG_405GP" = "y" ]; then
+      define_bool CONFIG_PPC4xx_EDMA y
+    fi
+    if [ "$CONFIG_STB03xxx" = "y" ]; then
+      define_bool CONFIG_STBXXX_DMA y
+    fi
+  fi
+
+#
+# Set other board specific options
+#
+  if [ "$CONFIG_OAK" = "y" -o "$CONFIG_TIVO" = "y" -o \
+       "$CONFIG_REDWOOD_5" = "y" -o "$CONFIG_REDWOOD_6" = "y" -o \
+       "$CONFIG_WALNUT" = "y" ]; then
+    define_bool CONFIG_IBM_OPENBIOS y
+  fi
+
+  if [ "$CONFIG_WALNUT" = "y" -o "$CONFIG_EP405" = "y" ]; then
+    define_bool CONFIG_BIOS_FIXUP y
+  fi
+
+fi
+
 if [ "$CONFIG_8xx" = "y" -o "$CONFIG_8260" = "y" ]; then
     define_bool CONFIG_EMBEDDEDBOOT y
 fi
@@ -148,8 +305,52 @@
 comment 'General setup'
 
 bool 'High memory support (experimental)' CONFIG_HIGHMEM
+if [ "$CONFIG_ADVANCED_OPTIONS" = "y" ]; then
+  if [ "$CONFIG_HIGHMEM" = "y" ]; then
+    bool "  Set high memory pool address" CONFIG_HIGHMEM_START_BOOL
+    if [ "$CONFIG_HIGHMEM_START_BOOL" = "y" ]; then
+      hex "    Virtual start address of high memory pool" CONFIG_HIGHMEM_START 0xfe000000
+    fi
+  fi
+  bool "  Set maximum low memory" CONFIG_LOWMEM_SIZE_BOOL
+  if [ "$CONFIG_LOWMEM_SIZE_BOOL" = "y" ]; then
+    hex "    Maximum low memory size (in bytes)" CONFIG_LOWMEM_SIZE 0x20000000
+  fi
+
+  bool "Set custom kernel base address" CONFIG_KERNEL_START_BOOL
+  if [ "$CONFIG_KERNEL_START_BOOL" = "y" ]; then
+    hex "  Virtual address of kernel base" CONFIG_KERNEL_START 0xc0000000
+  fi
+  bool "Set custom user task size" CONFIG_TASK_SIZE_BOOL
+  if [ "$CONFIG_TASK_SIZE_BOOL" = "y" ]; then
+    hex "  Size of user task space" CONFIG_TASK_SIZE 0x80000000
+  fi
+  if [ "$CONFIG_8xx" = "y" ]; then
+    bool "Pinned Kernel TLBs (86x ONLY)" CONFIG_PIN_TLB
+  fi
+fi
+
+if [ "$CONFIG_HIGHMEM_START_BOOL" != "y" ]; then
+  define_hex CONFIG_HIGHMEM_START 0xfe000000
+fi
+
+if [ "$CONFIG_LOWMEM_SIZE_BOOL" != "y" ]; then
+  define_hex CONFIG_LOWMEM_SIZE 0x30000000
+fi
 
-define_bool CONFIG_ISA n
+if [ "$CONFIG_KERNEL_START_BOOL" != "y" ]; then
+  define_hex CONFIG_KERNEL_START 0xc0000000
+fi
+
+if [ "$CONFIG_TASK_SIZE_BOOL" != "y" ]; then
+  define_hex CONFIG_TASK_SIZE 0x80000000
+fi
+
+if [ "$CONFIG_ALL_PPC" = "y" ]; then
+  bool 'Support for ISA-bus hardware' CONFIG_ISA
+else
+  define_bool CONFIG_ISA n
+fi
 define_bool CONFIG_EISA n
 define_bool CONFIG_SBUS n
 
@@ -157,7 +358,8 @@
 define_bool CONFIG_MCA n
 
 if [ "$CONFIG_4xx" = "y" -o "$CONFIG_8260" = "y" ]; then
-  define_bool CONFIG_PCI n
+  bool "Enable PCI" CONFIG_PCI
+  bool 'PC PS/2 style Keyboard' CONFIG_PC_KEYBOARD
 else
   if [ "$CONFIG_8xx" = "y" ]; then
      bool 'QSpan PCI' CONFIG_PCI_QSPAN
@@ -184,6 +386,7 @@
 define_bool CONFIG_BINFMT_ELF y
 define_bool CONFIG_KERNEL_ELF y
 tristate 'Kernel support for MISC binaries' CONFIG_BINFMT_MISC
+bool 'Select task to kill on out of memory condition' CONFIG_OOM_KILLER
 
 source drivers/pci/Config.in
 
@@ -213,7 +416,7 @@
   dep_bool '  Support for reading of PReP Residual Data in /proc' CONFIG_PROC_PREPRESIDUAL $CONFIG_PREP_RESIDUAL
   define_bool CONFIG_PPCBUG_NVRAM y
 fi
-if [ "$CONFIG_LOPEC" = "y" ]; then
+if [ "$CONFIG_PPLUS" = "y" -o "$CONFIG_LOPEC" = "y" ]; then
   bool 'Enable reading PPCBUG NVRAM during boot' CONFIG_PPCBUG_NVRAM
 fi
 
@@ -276,7 +479,6 @@
 if [ "$CONFIG_IDE" != "n" ]; then
   source drivers/ide/Config.in
 else
-  define_bool CONFIG_BLK_DEV_IDE_MODES n
   define_bool CONFIG_BLK_DEV_HD n
 fi
 endmenu
@@ -298,7 +500,7 @@
   bool 'Network device support' CONFIG_NETDEVICES
   if [ "$CONFIG_NETDEVICES" = "y" ]; then
     source drivers/net/Config.in
-    if [ "$CONFIG_ATM" = "y" ]; then
+    if [ "$CONFIG_ATM" = "y" -o "$CONFIG_ATM" = "m" ]; then
       source drivers/atm/Config.in
     fi
   fi
@@ -329,7 +531,7 @@
 
 mainmenu_option next_comment
 comment 'Console drivers'
-if [ "$CONFIG_4xx" != "y" -a "$CONFIG_8xx" != "y" ]; then
+if [ "$CONFIG_40x" != "y" -a "$CONFIG_8xx" != "y" ]; then
   bool 'Support for VGA Console' CONFIG_VGA_CONSOLE
 fi
  source drivers/video/Config.in
@@ -404,14 +606,15 @@
 source arch/ppc/8xx_io/Config.in
 fi
 
-if [ "$CONFIG_8260" = "y" ]; then
-source arch/ppc/8260_io/Config.in
+if [ "$CONFIG_CPM2" = "y" ]; then
+source arch/ppc/cpm2_io/Config.in
 fi
 
 source drivers/usb/Config.in
 
 source net/bluetooth/Config.in
 
+source crypto/Config.in
 source lib/Config.in
 
 mainmenu_option next_comment
@@ -461,4 +664,7 @@
 if [ "$CONFIG_GEN550" = "y" ]; then
   bool 'Support for early boot texts over serial port' CONFIG_SERIAL_TEXT_DEBUG
 fi
+
+int 'Kernel messages buffer length shift (0 = default)' CONFIG_LOG_BUF_SHIFT 0
+
 endmenu
Index: arch/ppc/vmlinux.lds
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/ppc/vmlinux.lds,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/ppc/vmlinux.lds	22 Jul 2004 19:48:59 -0000	1.1
+++ arch/ppc/vmlinux.lds	4 Aug 2004 01:26:06 -0000	1.2
@@ -64,6 +64,7 @@
   _edata  =  .;
   PROVIDE (edata = .);
 
+  . = ALIGN(8);
   .fixup   : { *(.fixup) }
   __start___ex_table = .;
   __ex_table : { *(__ex_table) }
@@ -73,6 +74,7 @@
   __ksymtab : { *(__ksymtab) }
   __stop___ksymtab = .;
 
+  . = ALIGN(8);
   __start___ftr_fixup = .;
   __ftr_fixup : { *(__ftr_fixup) }
   __stop___ftr_fixup = .;
@@ -83,7 +85,7 @@
   . = ALIGN(4096);
   __init_begin = .;
   .text.init : { *(.text.init) }
-  .data.init : { 
+  .data.init : {
     *(.data.init);
     __vtop_table_begin = .;
     *(.vtop_fixup);
@@ -138,6 +140,7 @@
    *(.bss)
    *(COMMON)
   }
+  . = ALIGN(4);
   _end = . ;
   PROVIDE (end = .);
 }
Index: arch/ppc/8xx_io/Config.in
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/ppc/8xx_io/Config.in,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/ppc/8xx_io/Config.in	22 Jul 2004 19:49:02 -0000	1.1
+++ arch/ppc/8xx_io/Config.in	4 Aug 2004 01:26:06 -0000	1.2
@@ -2,8 +2,14 @@
 # MPC8xx Communication options
 #
 mainmenu_option next_comment
-comment 'MPC8xx CPM Options'
+comment 'MPC8xx Options'
 
+comment 'Generic MPC8xx Options'
+bool 'Copy-Back Data Cache (else Writethrough)' CONFIG_8xx_COPYBACK
+bool 'CPU6 Silicon Errata (860 Pre Rev. C)' CONFIG_8xx_CPU6
+bool 'I2C/SPI Microcode Patch' CONFIG_UCODE_PATCH
+
+comment 'MPC8xx CPM Options'
 if [ "$CONFIG_NET_ETHERNET" = "y" ]; then
   bool 'CPM SCC Ethernet' CONFIG_SCC_ENET
   if [ "$CONFIG_SCC_ENET" = "y" ]; then
@@ -12,25 +18,28 @@
 	 SCC2	CONFIG_SCC2_ENET	\
 	 SCC3	CONFIG_SCC3_ENET"	SCC1
   fi
-  bool '860T FEC Ethernet' CONFIG_FEC_ENET
+  bool '8xxT FEC Ethernet' CONFIG_FEC_ENET
   if [ "$CONFIG_FEC_ENET" = "y" ]; then
     bool 'Use MDIO for PHY configuration' CONFIG_USE_MDIO
   fi
   bool 'Use Big CPM Ethernet Buffers' CONFIG_ENET_BIG_BUFFERS
 fi
-bool 'Use SMC2 for UART' CONFIG_SMC2_UART
-if [ "$CONFIG_SMC2_UART" = "y" ]; then
+if [ "$CONFIG_SCC3_ENET" != "y" ]; then
+  bool 'Use SMC1 for UART' CONFIG_8xx_SMC1
+fi
+bool 'Use SMC2 for UART' CONFIG_8xx_SMC2
+if [ "$CONFIG_8xx_SMC2" = "y" ]; then
   bool 'Use Alternate SMC2 I/O (823/850)' CONFIG_ALTSMC2
   bool 'Use SMC2 for Console' CONFIG_CONS_SMC2
 fi
-bool 'Enable SCC2 and SCC3 for UART' CONFIG_USE_SCC_IO
-
-# This doesn't really belong here, but it is convenient to ask
-# 8xx specific questions.
-
-comment 'Generic MPC8xx Options'
-bool 'Copy-Back Data Cache (else Writethrough)' CONFIG_8xx_COPYBACK
-bool 'CPU6 Silicon Errata (860 Pre Rev. C)' CONFIG_8xx_CPU6
-bool 'I2C/SPI Microcode Patch' CONFIG_UCODE_PATCH
-
+if [ "$CONFIG_SCC1_ENET" != "y" ]; then
+  bool 'Use SCC1 for UART' CONFIG_8xx_SCC1 
+fi
+if [ "$CONFIG_SCC2_ENET" != "y" ]; then
+  bool 'Use SCC2 for UART' CONFIG_8xx_SCC2
+fi
+if [ "$CONFIG_SCC3_ENET" != "y" ]; then
+  bool 'Use SCC3 for UART' CONFIG_8xx_SCC3
+fi
+bool 'Use SCC4 for UART' CONFIG_8xx_SCC4
 endmenu
Index: arch/ppc/8xx_io/commproc.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/ppc/8xx_io/commproc.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/ppc/8xx_io/commproc.c	22 Jul 2004 19:49:02 -0000	1.1
+++ arch/ppc/8xx_io/commproc.c	4 Aug 2004 01:26:06 -0000	1.2
@@ -54,6 +54,7 @@
 static	struct	cpm_action cpm_vecs[CPMVEC_NR];
 static	void	cpm_interrupt(int irq, void * dev, struct pt_regs * regs);
 static	void	cpm_error_interrupt(int irq, void *, struct pt_regs * regs);
+static	void	alloc_host_memory(void);
 
 /* Define a table of names to identify CPM interrupt handlers in
  * /proc/interrupts.
@@ -104,7 +105,7 @@
 };
 
 void
-m8xx_cpm_reset(uint host_page_addr)
+m8xx_cpm_reset()
 {
 	volatile immap_t	 *imp;
 	volatile cpm8xx_t	*commproc;
@@ -130,7 +131,7 @@
 	 * this is what we realy want for some applications, but the
 	 * manual recommends it.
 	 * Bit 25, FAM can also be set to use FEC aggressive mode (860T).
-	*/
+	 */
 	imp->im_siu_conf.sc_sdcr = 1;
 
 	/* Reclaim the DP memory for our use.
@@ -138,25 +139,23 @@
 	dp_alloc_base = CPM_DATAONLY_BASE;
 	dp_alloc_top = dp_alloc_base + CPM_DATAONLY_SIZE;
 
-	/* Set the host page for allocation.
+	/* Tell everyone where the comm processor resides.
 	*/
-	host_buffer = host_page_addr;	/* Host virtual page address */
-	host_end = host_page_addr + PAGE_SIZE;
+	cpmp = (cpm8xx_t *)commproc;
+}
 
-	/* We need to get this page early, so I have to do it the
-	 * hard way.
-	 */
-	if (get_pteptr(&init_mm, host_page_addr, &pte)) {
-		pte_val(*pte) |= _PAGE_NO_CACHE;
-		flush_tlb_page(init_mm.mmap, host_buffer);
-	}
-	else {
-		panic("Huh?  No CPM host page?");
-	}
+/* We used to do this earlier, but have to postpone as long as possible
+ * to ensure the kernel VM is now running.
+ */
+static void
+alloc_host_memory()
+{
+	uint	physaddr;
 
-	/* Tell everyone where the comm processor resides.
+	/* Set the host page for allocation.
 	*/
-	cpmp = (cpm8xx_t *)commproc;
+	host_buffer = (uint)consistent_alloc(GFP_KERNEL, PAGE_SIZE, &physaddr);
+	host_end = host_buffer + PAGE_SIZE;
 }
 
 /* This is called during init_IRQ.  We used to do it above, but this
@@ -321,6 +320,9 @@
 {
 	uint	retloc;
 
+	if (host_buffer == 0)
+		alloc_host_memory();
+
 	if ((host_buffer + size) >= host_end)
 		return(0);
 
